blob: f70af1377e8d56a96021cc414c0695d7c7162349 [file] [log] [blame]
Phaneendra Manda4c62c802019-03-06 21:37:49 +05301#
2# Copyright 2016 the original author or authors.
3#
4# Licensed under the Apache License, Version 2.0 (the "License");
5# you may not use this file except in compliance with the License.
6# You may obtain a copy of the License at
7#
8# http://www.apache.org/licenses/LICENSE-2.0
9#
10# Unless required by applicable law or agreed to in writing, software
11# distributed under the License is distributed on an "AS IS" BASIS,
12# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13# See the License for the specific language governing permissions and
14# limitations under the License.
15#
16
Matt Jeanneret8b823f62019-05-11 11:01:28 -040017# set default shell
18SHELL = bash -e -o pipefail
19
20# Variables
21VERSION ?= $(shell cat ./VERSION)
22
Matt Jeanneretf880eb62019-07-16 20:08:03 -040023DOCKER_LABEL_VCS_DIRTY = false
24ifneq ($(shell git ls-files --others --modified --exclude-standard 2>/dev/null | wc -l | sed -e 's/ //g'),0)
25 DOCKER_LABEL_VCS_DIRTY = true
26endif
Matt Jeanneret8b823f62019-05-11 11:01:28 -040027## Docker related
Matt Jeanneretf880eb62019-07-16 20:08:03 -040028DOCKER_EXTRA_ARGS ?=
Matt Jeanneret8b823f62019-05-11 11:01:28 -040029DOCKER_REGISTRY ?=
30DOCKER_REPOSITORY ?=
Matt Jeanneret8b823f62019-05-11 11:01:28 -040031DOCKER_TAG ?= ${VERSION}
Matt Jeanneretb5bf10e2019-05-18 15:02:51 -040032ADAPTER_IMAGENAME := ${DOCKER_REGISTRY}${DOCKER_REPOSITORY}voltha-openolt-adapter:${DOCKER_TAG}
Andrea Campanellacbf583e2019-12-17 15:26:00 -080033TYPE ?= minimal
Matt Jeanneret8b823f62019-05-11 11:01:28 -040034
35## Docker labels. Only set ref and commit date if committed
Matt Jeanneretf880eb62019-07-16 20:08:03 -040036DOCKER_LABEL_VCS_URL ?= $(shell git remote get-url $(shell git remote))
37DOCKER_LABEL_VCS_REF = $(shell git rev-parse HEAD)
38DOCKER_LABEL_BUILD_DATE ?= $(shell date -u "+%Y-%m-%dT%H:%M:%SZ")
39DOCKER_LABEL_COMMIT_DATE = $(shell git show -s --format=%cd --date=iso-strict HEAD)
Matt Jeanneret8b823f62019-05-11 11:01:28 -040040
Matt Jeanneretf880eb62019-07-16 20:08:03 -040041DOCKER_BUILD_ARGS ?= \
42 ${DOCKER_EXTRA_ARGS} \
43 --build-arg org_label_schema_version="${VERSION}" \
44 --build-arg org_label_schema_vcs_url="${DOCKER_LABEL_VCS_URL}" \
45 --build-arg org_label_schema_vcs_ref="${DOCKER_LABEL_VCS_REF}" \
46 --build-arg org_label_schema_build_date="${DOCKER_LABEL_BUILD_DATE}" \
47 --build-arg org_opencord_vcs_commit_date="${DOCKER_LABEL_COMMIT_DATE}" \
48 --build-arg org_opencord_vcs_dirty="${DOCKER_LABEL_VCS_DIRTY}"
49
Kent Hagerman2cd4b7b2020-02-04 15:15:14 -050050# tool containers
Kent Hagermane71b52d2020-02-26 11:13:42 -050051VOLTHA_TOOLS_VERSION ?= 2.0.0
Kent Hagerman2cd4b7b2020-02-04 15:15:14 -050052
Kent Hagerman52830082020-02-14 14:53:52 -050053GO = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app $(shell test -t 0 && echo "-it") -v gocache:/.cache -v gocache-${VOLTHA_TOOLS_VERSION}:/go/pkg voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-golang go
Kent Hagerman2cd4b7b2020-02-04 15:15:14 -050054GO_JUNIT_REPORT = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app -i voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-go-junit-report go-junit-report
55GOCOVER_COBERTURA = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app -i voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-gocover-cobertura gocover-cobertura
Kent Hagerman52830082020-02-14 14:53:52 -050056GOLANGCI_LINT = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app $(shell test -t 0 && echo "-it") -v gocache:/.cache -v gocache-${VOLTHA_TOOLS_VERSION}:/go/pkg voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-golangci-lint golangci-lint
57HADOLINT = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app $(shell test -t 0 && echo "-it") voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-hadolint hadolint
Kent Hagerman2cd4b7b2020-02-04 15:15:14 -050058
Scott Baker355d1742019-10-24 10:57:52 -070059.PHONY: docker-build local-protos local-lib-go
Phaneendra Manda4c62c802019-03-06 21:37:49 +053060
61# This should to be the first and default target in this Makefile
62help:
63 @echo "Usage: make [<target>]"
64 @echo "where available targets are:"
David Bainbridge788e5202019-10-21 18:49:40 +000065 @echo ""
66 @echo "clean : Removes any local filesystem artifacts generated by a build"
67 @echo "distclean : Removes any local filesystem artifacts generated by a build or test run"
David Bainbridge63d51812019-10-22 15:55:29 +000068 @echo "build : Build all openolt adapter artifacts"
Zack Williams95504be2019-09-03 14:17:24 -070069 @echo "docker-build : Build openolt adapter docker image"
Matt Jeanneret8b823f62019-05-11 11:01:28 -040070 @echo "docker-push : Push the docker images to an external repository"
David Bainbridge788e5202019-10-21 18:49:40 +000071 @echo "help : Print this help"
72 @echo "lint : Run all lint targets"
Kent Hagerman2cd4b7b2020-02-04 15:15:14 -050073 @echo "lint-dockerfile : Perform static analysis on Dockerfiles"
David Bainbridge788e5202019-10-21 18:49:40 +000074 @echo "lint-mod : Verify the Go dependencies"
David Bainbridge788e5202019-10-21 18:49:40 +000075 @echo "local-protos : Copies a local verison of the VOLTHA protos into the vendor directory"
Scott Baker355d1742019-10-24 10:57:52 -070076 @echo "local-lib-go : Copies a local version of the VOTLHA dependencies into the vendor directory"
Girish Gowdru6a80bbd2019-07-02 07:36:09 -070077 @echo "sca : Runs various SCA through golangci-lint tool"
Matt Jeanneret8b823f62019-05-11 11:01:28 -040078 @echo "test : Run unit tests, if any"
Phaneendra Manda4c62c802019-03-06 21:37:49 +053079 @echo
80
Matt Jeanneretb5bf10e2019-05-18 15:02:51 -040081## Local Development Helpers
Phaneendra Manda4c62c802019-03-06 21:37:49 +053082
Matt Jeanneret8b823f62019-05-11 11:01:28 -040083local-protos:
William Kurkianea869482019-04-09 15:16:11 -040084ifdef LOCAL_PROTOS
Esin Karamanccb714b2019-11-29 15:02:06 +000085 rm -rf vendor/github.com/opencord/voltha-protos/v3/go
86 mkdir -p vendor/github.com/opencord/voltha-protos/v3/go
87 cp -r ${LOCAL_PROTOS}/go/* vendor/github.com/opencord/voltha-protos/v3/go
88 rm -rf vendor/github.com/opencord/voltha-protos/v3/go/vendor
Matt Jeanneretb5bf10e2019-05-18 15:02:51 -040089endif
90
Scott Baker355d1742019-10-24 10:57:52 -070091## Local Development Helpers
92local-lib-go:
93ifdef LOCAL_LIB_GO
Esin Karamanccb714b2019-11-29 15:02:06 +000094 mkdir -p vendor/github.com/opencord/voltha-lib-go/v3/pkg
95 cp -r ${LOCAL_LIB_GO}/pkg/* vendor/github.com/opencord/voltha-lib-go/v3/pkg/
William Kurkianea869482019-04-09 15:16:11 -040096endif
Matt Jeanneret8b823f62019-05-11 11:01:28 -040097
Matt Jeanneretb5bf10e2019-05-18 15:02:51 -040098## Docker targets
99
David Bainbridge63d51812019-10-22 15:55:29 +0000100build: docker-build
101
Scott Baker355d1742019-10-24 10:57:52 -0700102docker-build: local-protos local-lib-go
David K. Bainbridge8eb6cd62019-08-22 13:17:29 -0700103 docker build $(DOCKER_BUILD_ARGS) -t ${ADAPTER_IMAGENAME} -f docker/Dockerfile.openolt .
Matt Jeanneretb5bf10e2019-05-18 15:02:51 -0400104
Matt Jeanneret8b823f62019-05-11 11:01:28 -0400105docker-push:
106 docker push ${ADAPTER_IMAGENAME}
107
Andrea Campanellacbf583e2019-12-17 15:26:00 -0800108docker-kind-load:
109 @if [ "`kind get clusters | grep voltha-$(TYPE)`" = '' ]; then echo "no voltha-$(TYPE) cluster found" && exit 1; fi
110 kind load docker-image ${ADAPTER_IMAGENAME} --name=voltha-$(TYPE) --nodes $(shell kubectl get nodes --template='{{range .items}}{{.metadata.name}},{{end}}' | sed 's/,$$//')
111
112
Matt Jeanneret8b823f62019-05-11 11:01:28 -0400113## lint and unit tests
Phaneendra Manda4c62c802019-03-06 21:37:49 +0530114
Kent Hagerman2cd4b7b2020-02-04 15:15:14 -0500115lint-dockerfile:
116 @echo "Running Dockerfile lint check ..."
117 @${HADOLINT} $$(find . -name "Dockerfile.*")
118 @echo "Dockerfile lint check OK"
119
David Bainbridge788e5202019-10-21 18:49:40 +0000120lint-mod:
Matt Jeanneret384d8c92019-05-06 14:27:31 -0400121 @echo "Running dependency check..."
Kent Hagerman2cd4b7b2020-02-04 15:15:14 -0500122 @${GO} mod verify
Scott Baker22c0e9c2019-11-26 08:11:29 -0800123 @echo "Dependency check OK. Running vendor check..."
124 @git status > /dev/null
Kent Hagermane71b52d2020-02-26 11:13:42 -0500125 @git diff-index --quiet HEAD -- go.mod go.sum vendor || (echo "ERROR: Staged or modified files must be committed before running this test" && git status -- go.mod go.sum vendor && exit 1)
126 @[[ `git ls-files --exclude-standard --others go.mod go.sum vendor` == "" ]] || (echo "ERROR: Untracked files must be cleaned up before running this test" && git status -- go.mod go.sum vendor && exit 1)
Kent Hagerman2cd4b7b2020-02-04 15:15:14 -0500127 ${GO} mod tidy
128 ${GO} mod vendor
Scott Baker22c0e9c2019-11-26 08:11:29 -0800129 @git status > /dev/null
Kent Hagermane71b52d2020-02-26 11:13:42 -0500130 @git diff-index --quiet HEAD -- go.mod go.sum vendor || (echo "ERROR: Modified files detected after running go mod tidy / go mod vendor" && git status -- go.mod go.sum vendor && git checkout -- go.mod go.sum vendor && exit 1)
131 @[[ `git ls-files --exclude-standard --others go.mod go.sum vendor` == "" ]] || (echo "ERROR: Untracked files detected after running go mod tidy / go mod vendor" && git status -- go.mod go.sum vendor && git checkout -- go.mod go.sum vendor && exit 1)
Scott Baker22c0e9c2019-11-26 08:11:29 -0800132 @echo "Vendor check OK."
Matt Jeanneret384d8c92019-05-06 14:27:31 -0400133
Kent Hagermane71b52d2020-02-26 11:13:42 -0500134lint: local-lib-go lint-mod lint-dockerfile
David Bainbridge788e5202019-10-21 18:49:40 +0000135
Kent Hagerman2cd4b7b2020-02-04 15:15:14 -0500136test:
Matt Jeanneret384d8c92019-05-06 14:27:31 -0400137 @mkdir -p ./tests/results
Kent Hagerman2cd4b7b2020-02-04 15:15:14 -0500138 @${GO} test -mod=vendor -v -coverprofile ./tests/results/go-test-coverage.out -covermode count ./... 2>&1 | tee ./tests/results/go-test-results.out ;\
Matt Jeanneret384d8c92019-05-06 14:27:31 -0400139 RETURN=$$? ;\
Kent Hagerman2cd4b7b2020-02-04 15:15:14 -0500140 ${GO_JUNIT_REPORT} < ./tests/results/go-test-results.out > ./tests/results/go-test-results.xml ;\
141 ${GOCOVER_COBERTURA} < ./tests/results/go-test-coverage.out > ./tests/results/go-test-coverage.xml ;\
Matt Jeanneret384d8c92019-05-06 14:27:31 -0400142 exit $$RETURN
143
Kent Hagerman2cd4b7b2020-02-04 15:15:14 -0500144sca:
Kent Hagermane71b52d2020-02-26 11:13:42 -0500145 @rm -rf ./sca-report
Girish Gowdru6a80bbd2019-07-02 07:36:09 -0700146 @mkdir -p ./sca-report
Kent Hagerman2cd4b7b2020-02-04 15:15:14 -0500147 @echo "Running static code analysis..."
148 @${GOLANGCI_LINT} run --deadline=4m --out-format junit-xml ./... | tee ./sca-report/sca-report.xml
Kent Hagermane71b52d2020-02-26 11:13:42 -0500149 @echo ""
Kent Hagerman2cd4b7b2020-02-04 15:15:14 -0500150 @echo "Static code analysis OK"
Girish Gowdru6a80bbd2019-07-02 07:36:09 -0700151
Kent Hagerman2cd4b7b2020-02-04 15:15:14 -0500152clean: distclean
Matt Jeanneretb5bf10e2019-05-18 15:02:51 -0400153
Kent Hagerman2cd4b7b2020-02-04 15:15:14 -0500154distclean:
155 rm -rf ./sca-report
Matt Jeanneretb5bf10e2019-05-18 15:02:51 -0400156
Kent Hagerman2cd4b7b2020-02-04 15:15:14 -0500157mod-update:
158 ${GO} mod tidy
159 ${GO} mod vendor